//+------------------------------------------------------------------+
//|                                          Complex.mq5 |
//|                        Copyright 2009, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2009, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "2.00"
#property indicator_separate_window
#property indicator_buffers 50
#property indicator_plots   1
//#property indicator_applied_price PRICE_TYPICAL
//---      MovingAverages.mqh
#include <MovingAverages.mqh>
//---- plot TSI
#property indicator_label1  "Complex2"
#property indicator_type1   DRAW_LINE
#property indicator_color1  Green
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input int MA_Slow=56;                         //MA_Slow
input ENUM_TIMEFRAMES MA_Slow_TF = PERIOD_H1; //MA_Slow_TF
input int MA_Fast=9;                          //MA_Fast
input ENUM_TIMEFRAMES MA_Fast_TF = PERIOD_H1; //MA_Fast_TF

input double kUSD=1;
input double kGBP=1;
input double kJPY=1;
input double kEUR=1;
//--- indicator buffers
double pair[];

   double OPEN_S_EURUSD[],HIGH_S_EURUSD[],LOW_S_EURUSD[],CLOSE_S_EURUSD[];
   double OPEN_F_EURUSD[],HIGH_F_EURUSD[],LOW_F_EURUSD[],CLOSE_F_EURUSD[];   
//-------------------------------
   double OPEN_S_GBPUSD[],HIGH_S_GBPUSD[],LOW_S_GBPUSD[],CLOSE_S_GBPUSD[];
   double OPEN_F_GBPUSD[],HIGH_F_GBPUSD[],LOW_F_GBPUSD[],CLOSE_F_GBPUSD[];
//-------------------------------
   double OPEN_S_EURGBP[],HIGH_S_EURGBP[],LOW_S_EURGBP[],CLOSE_S_EURGBP[];
   double OPEN_F_EURGBP[],HIGH_F_EURGBP[],LOW_F_EURGBP[],CLOSE_F_EURGBP[];   
//-------------------------------
   double OPEN_S_EURJPY[],HIGH_S_EURJPY[],LOW_S_EURJPY[],CLOSE_S_EURJPY[];
   double OPEN_F_EURJPY[],HIGH_F_EURJPY[],LOW_F_EURJPY[],CLOSE_F_EURJPY[];
//-------------------------------
   double OPEN_S_USDJPY[],HIGH_S_USDJPY[],LOW_S_USDJPY[],CLOSE_S_USDJPY[];
   double OPEN_F_USDJPY[],HIGH_F_USDJPY[],LOW_F_USDJPY[],CLOSE_F_USDJPY[];
//-------------------------------
   double OPEN_S_GBPJPY[],HIGH_S_GBPJPY[],LOW_S_GBPJPY[],CLOSE_S_GBPJPY[];
   double OPEN_F_GBPJPY[],HIGH_F_GBPJPY[],LOW_F_GBPJPY[],CLOSE_F_GBPJPY[];

//--------------------------    ------------------
int hMA_OPEN_S_EURUSD, hMA_HIGH_S_EURUSD, hMA_LOW_S_EURUSD, hMA_CLOSE_S_EURUSD,
    hMA_OPEN_F_EURUSD, hMA_HIGH_F_EURUSD, hMA_LOW_F_EURUSD, hMA_CLOSE_F_EURUSD;
    
int hMA_OPEN_S_GBPUSD, hMA_HIGH_S_GBPUSD, hMA_LOW_S_GBPUSD, hMA_CLOSE_S_GBPUSD,
    hMA_OPEN_F_GBPUSD, hMA_HIGH_F_GBPUSD, hMA_LOW_F_GBPUSD, hMA_CLOSE_F_GBPUSD;    
   
int hMA_OPEN_S_USDJPY, hMA_HIGH_S_USDJPY, hMA_LOW_S_USDJPY, hMA_CLOSE_S_USDJPY,
    hMA_OPEN_F_USDJPY, hMA_HIGH_F_USDJPY, hMA_LOW_F_USDJPY, hMA_CLOSE_F_USDJPY;
  
int hMA_OPEN_S_EURGBP, hMA_HIGH_S_EURGBP, hMA_LOW_S_EURGBP, hMA_CLOSE_S_EURGBP,
    hMA_OPEN_F_EURGBP, hMA_HIGH_F_EURGBP, hMA_LOW_F_EURGBP, hMA_CLOSE_F_EURGBP;
    
int hMA_OPEN_S_EURJPY, hMA_HIGH_S_EURJPY, hMA_LOW_S_EURJPY, hMA_CLOSE_S_EURJPY,
    hMA_OPEN_F_EURJPY, hMA_HIGH_F_EURJPY, hMA_LOW_F_EURJPY, hMA_CLOSE_F_EURJPY;
                
int hMA_OPEN_S_GBPJPY, hMA_HIGH_S_GBPJPY, hMA_LOW_S_GBPJPY, hMA_CLOSE_S_GBPJPY,
    hMA_OPEN_F_GBPJPY, hMA_HIGH_F_GBPJPY, hMA_LOW_F_GBPJPY, hMA_CLOSE_F_GBPJPY;
    

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,pair,INDICATOR_DATA);         
   
   SetIndexBuffer(1,OPEN_S_EURUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(2,HIGH_S_EURUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(3,LOW_S_EURUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(4,CLOSE_S_EURUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(5,OPEN_F_EURUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(6,HIGH_F_EURUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(7,LOW_F_EURUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(8,CLOSE_F_EURUSD,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(9,OPEN_S_GBPUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(10,HIGH_S_GBPUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(11,LOW_S_GBPUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(12,CLOSE_S_GBPUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(13,OPEN_F_GBPUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(14,HIGH_F_GBPUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(15,LOW_F_GBPUSD,INDICATOR_CALCULATIONS);
   SetIndexBuffer(16,CLOSE_F_GBPUSD,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(17,OPEN_S_EURGBP,INDICATOR_CALCULATIONS);
   SetIndexBuffer(18,HIGH_S_EURGBP,INDICATOR_CALCULATIONS);
   SetIndexBuffer(19,LOW_S_EURGBP,INDICATOR_CALCULATIONS);
   SetIndexBuffer(20,CLOSE_S_EURGBP,INDICATOR_CALCULATIONS);
   SetIndexBuffer(21,OPEN_F_EURGBP,INDICATOR_CALCULATIONS);
   SetIndexBuffer(22,HIGH_F_EURGBP,INDICATOR_CALCULATIONS);
   SetIndexBuffer(23,LOW_F_EURGBP,INDICATOR_CALCULATIONS);
   SetIndexBuffer(24,CLOSE_F_EURGBP,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(25,OPEN_S_EURJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(26,HIGH_S_EURJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(27,LOW_S_EURJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(28,CLOSE_S_EURJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(29,OPEN_F_EURJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(30,HIGH_F_EURJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(31,LOW_F_EURJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(32,CLOSE_F_EURJPY,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(33,OPEN_S_USDJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(34,HIGH_S_USDJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(35,LOW_S_USDJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(36,CLOSE_S_USDJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(37,OPEN_F_USDJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(38,HIGH_F_USDJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(39,LOW_F_USDJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(40,CLOSE_F_USDJPY,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(41,OPEN_S_GBPJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(42,HIGH_S_GBPJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(43,LOW_S_GBPJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(44,CLOSE_S_GBPJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(45,OPEN_F_GBPJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(46,HIGH_F_GBPJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(47,LOW_F_GBPJPY,INDICATOR_CALCULATIONS);
   SetIndexBuffer(48,CLOSE_F_GBPJPY,INDICATOR_CALCULATIONS);
   
   
      
  
   
   //hMA1=iMA(NULL,MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_WEIGHTED);
   //hMA2=iMA(NULL,MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_WEIGHTED);  
//---------------------------   
   hMA_OPEN_S_EURUSD=iMA("EURUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_S_EURUSD=iMA("EURUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_S_EURUSD=iMA("EURUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_S_EURUSD=iMA("EURUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_CLOSE);  
   
   hMA_OPEN_F_EURUSD=iMA("EURUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_F_EURUSD=iMA("EURUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_F_EURUSD=iMA("EURUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_F_EURUSD=iMA("EURUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_CLOSE);
//---------------------------   
   hMA_OPEN_S_GBPUSD=iMA("GBPUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_S_GBPUSD=iMA("GBPUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_S_GBPUSD=iMA("GBPUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_S_GBPUSD=iMA("GBPUSD",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_CLOSE);  
   
   hMA_OPEN_F_GBPUSD=iMA("GBPUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_F_GBPUSD=iMA("GBPUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_F_GBPUSD=iMA("GBPUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_F_GBPUSD=iMA("GBPUSD",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_CLOSE);
//----------------------------   
   hMA_OPEN_S_USDJPY=iMA("USDJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_S_USDJPY=iMA("USDJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_S_USDJPY=iMA("USDJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_S_USDJPY=iMA("USDJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_CLOSE);  
   
   hMA_OPEN_F_USDJPY=iMA("USDJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_F_USDJPY=iMA("USDJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_F_USDJPY=iMA("USDJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_F_USDJPY=iMA("USDJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_CLOSE);
//---------------------------   
   hMA_OPEN_S_EURGBP=iMA("EURGBP",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_S_EURGBP=iMA("EURGBP",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_S_EURGBP=iMA("EURGBP",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_S_EURGBP=iMA("EURGBP",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_CLOSE);  
   
   hMA_OPEN_F_EURGBP=iMA("EURGBP",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_F_EURGBP=iMA("EURGBP",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_F_EURGBP=iMA("EURGBP",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_F_EURGBP=iMA("EURGBP",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_CLOSE);   
//----------------------------      
   hMA_OPEN_S_EURJPY=iMA("EURJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_S_EURJPY=iMA("EURJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_S_EURJPY=iMA("EURJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_S_EURJPY=iMA("EURJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_CLOSE);  
   
   hMA_OPEN_F_EURJPY=iMA("EURJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_F_EURJPY=iMA("EURJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_F_EURJPY=iMA("EURJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_F_EURJPY=iMA("EURJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_CLOSE);   
//----------------------------      
   hMA_OPEN_S_GBPJPY=iMA("GBPJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_S_GBPJPY=iMA("GBPJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_S_GBPJPY=iMA("GBPJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_S_GBPJPY=iMA("GBPJPY",MA_Slow_TF,MA_Slow,0,MODE_LWMA,PRICE_CLOSE);  
   
   hMA_OPEN_F_GBPJPY=iMA("GBPJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_OPEN);
   hMA_HIGH_F_GBPJPY=iMA("GBPJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_HIGH);  
   hMA_LOW_F_GBPJPY=iMA("GBPJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_LOW);
   hMA_CLOSE_F_GBPJPY=iMA("GBPJPY",MA_Fast_TF,MA_Fast,0,MODE_LWMA,PRICE_CLOSE);   
//----------------------------      
           
   
       
   
//---      
//   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,r+s-1);
   string shortname;
   StringConcatenate(shortname,"Complex(",MA_Slow,",",MA_Fast,")");
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,shortname);   
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,5);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])

  {   

  double OPEN,HIGH,LOW,CLOSE;
   int i;  

   CopyBuffer( hMA_OPEN_S_EURUSD,1,0,1000,OPEN_S_EURUSD); 
   CopyBuffer( hMA_HIGH_S_EURUSD,2,0,1000,HIGH_S_EURUSD);
   CopyBuffer( hMA_LOW_S_EURUSD,3,0,1000,LOW_S_EURUSD);
   CopyBuffer( hMA_CLOSE_S_EURUSD,4,0,1000,CLOSE_S_EURUSD);
   
   CopyBuffer( hMA_OPEN_F_EURUSD,5,0,1000,OPEN_F_EURUSD);
   CopyBuffer( hMA_HIGH_F_EURUSD,6,0,1000,HIGH_F_EURUSD);
   CopyBuffer( hMA_LOW_F_EURUSD,7,0,1000,LOW_F_EURUSD);
   CopyBuffer( hMA_CLOSE_F_EURUSD,8,0,1000,CLOSE_F_EURUSD);  
//-----------------------------------------------    
   
   CopyBuffer( hMA_OPEN_S_GBPUSD,9,0,1000,OPEN_S_GBPUSD); 
   CopyBuffer( hMA_HIGH_S_GBPUSD,10,0,1000,HIGH_S_GBPUSD);
   CopyBuffer( hMA_LOW_S_GBPUSD,11,0,1000,LOW_S_GBPUSD);
   CopyBuffer( hMA_CLOSE_S_GBPUSD,12,0,1000,CLOSE_S_GBPUSD);
   
   CopyBuffer( hMA_OPEN_F_GBPUSD,13,0,1000,OPEN_F_GBPUSD);
   CopyBuffer( hMA_HIGH_F_GBPUSD,14,0,1000,HIGH_F_GBPUSD);
   CopyBuffer( hMA_LOW_F_GBPUSD,15,0,1000,LOW_F_GBPUSD);
   CopyBuffer( hMA_CLOSE_F_GBPUSD,16,0,1000,CLOSE_F_GBPUSD);  
//-----------------------------------------------   
   
   CopyBuffer( hMA_OPEN_S_EURGBP,17,0,1000,OPEN_S_EURGBP); 
   CopyBuffer( hMA_HIGH_S_EURGBP,18,0,1000,HIGH_S_EURGBP);
   CopyBuffer( hMA_LOW_S_EURGBP,19,0,1000,LOW_S_EURGBP);
   CopyBuffer( hMA_CLOSE_S_EURGBP,20,0,1000,CLOSE_S_EURGBP);
   
   CopyBuffer( hMA_OPEN_F_EURGBP,21,0,1000,OPEN_F_EURGBP);
   CopyBuffer( hMA_HIGH_F_EURGBP,22,0,1000,HIGH_F_EURGBP);
   CopyBuffer( hMA_LOW_F_EURGBP,23,0,1000,LOW_F_EURGBP);
   CopyBuffer( hMA_CLOSE_F_EURGBP,24,0,1000,CLOSE_F_EURGBP);  
//----------------------------------------------   
   
   CopyBuffer( hMA_OPEN_S_EURJPY,25,0,1000,OPEN_S_EURJPY); 
   CopyBuffer( hMA_HIGH_S_EURJPY,26,0,1000,HIGH_S_EURJPY);
   CopyBuffer( hMA_LOW_S_EURJPY,27,0,1000,LOW_S_EURJPY);
   CopyBuffer( hMA_CLOSE_S_EURJPY,28,0,1000,CLOSE_S_EURJPY);
   
   CopyBuffer( hMA_OPEN_F_EURJPY,29,0,1000,OPEN_F_EURJPY);
   CopyBuffer( hMA_HIGH_F_EURJPY,30,0,1000,HIGH_F_EURJPY);
   CopyBuffer( hMA_LOW_F_EURJPY,31,0,1000,LOW_F_EURJPY);
   CopyBuffer( hMA_CLOSE_F_EURJPY,32,0,1000,CLOSE_F_EURJPY);  
//---------------------------------------------------------   
   
   CopyBuffer( hMA_OPEN_S_USDJPY,33,0,1000,OPEN_S_USDJPY); 
   CopyBuffer( hMA_HIGH_S_USDJPY,34,0,1000,HIGH_S_USDJPY);
   CopyBuffer( hMA_LOW_S_USDJPY,35,0,1000,LOW_S_USDJPY);
   CopyBuffer( hMA_CLOSE_S_USDJPY,36,0,1000,CLOSE_S_USDJPY);
   
   CopyBuffer( hMA_OPEN_F_USDJPY,37,0,1000,OPEN_F_USDJPY);
   CopyBuffer( hMA_HIGH_F_USDJPY,38,0,1000,HIGH_F_USDJPY);
   CopyBuffer( hMA_LOW_F_USDJPY,39,0,1000,LOW_F_USDJPY);
   CopyBuffer( hMA_CLOSE_F_USDJPY,40,0,1000,CLOSE_F_USDJPY);
//----------------------------------------------------------
  
   CopyBuffer( hMA_OPEN_S_GBPJPY,41,0,1000,OPEN_S_GBPJPY); 
   CopyBuffer( hMA_HIGH_S_GBPJPY,42,0,1000,HIGH_S_GBPJPY);
   CopyBuffer( hMA_LOW_S_GBPJPY,43,0,1000,LOW_S_GBPJPY);
   CopyBuffer( hMA_CLOSE_S_GBPJPY,44,0,1000,CLOSE_S_GBPJPY);
   
   CopyBuffer( hMA_OPEN_F_GBPJPY,45,0,1000,OPEN_F_GBPJPY);
   CopyBuffer( hMA_HIGH_F_GBPJPY,46,0,1000,HIGH_F_GBPJPY);
   CopyBuffer( hMA_LOW_F_GBPJPY,47,0,1000,LOW_F_GBPJPY);
   CopyBuffer( hMA_CLOSE_F_GBPJPY,48,0,1000,CLOSE_F_GBPJPY); 
//----------------------------------------------------------       
     
   ArraySetAsSeries(OPEN_S_EURUSD,true);
   ArraySetAsSeries(HIGH_S_EURUSD,true);
   ArraySetAsSeries(LOW_S_EURUSD,true);
   ArraySetAsSeries(CLOSE_S_EURUSD,true);
   ArraySetAsSeries(OPEN_F_EURUSD,true);
   ArraySetAsSeries(HIGH_F_EURUSD,true);
   ArraySetAsSeries(LOW_F_EURUSD,true);
   ArraySetAsSeries(CLOSE_F_EURUSD,true);       
       
     
   ArraySetAsSeries(OPEN_S_GBPUSD,true);
   ArraySetAsSeries(HIGH_S_GBPUSD,true);
   ArraySetAsSeries(LOW_S_GBPUSD,true);
   ArraySetAsSeries(CLOSE_S_GBPUSD,true);
   ArraySetAsSeries(OPEN_F_GBPUSD,true);
   ArraySetAsSeries(HIGH_F_GBPUSD,true);
   ArraySetAsSeries(LOW_F_GBPUSD,true);
   ArraySetAsSeries(CLOSE_F_GBPUSD,true);    
          
     
   ArraySetAsSeries(OPEN_S_EURGBP,true);
   ArraySetAsSeries(HIGH_S_EURGBP,true);
   ArraySetAsSeries(LOW_S_EURGBP,true);
   ArraySetAsSeries(CLOSE_S_EURGBP,true);
   ArraySetAsSeries(OPEN_F_EURGBP,true);
   ArraySetAsSeries(HIGH_F_EURGBP,true);
   ArraySetAsSeries(LOW_F_EURGBP,true);
   ArraySetAsSeries(CLOSE_F_EURGBP,true);     
       
     
   ArraySetAsSeries(OPEN_S_EURJPY,true);
   ArraySetAsSeries(HIGH_S_EURJPY,true);
   ArraySetAsSeries(LOW_S_EURJPY,true);
   ArraySetAsSeries(CLOSE_S_EURJPY,true);
   ArraySetAsSeries(OPEN_F_EURJPY,true);
   ArraySetAsSeries(HIGH_F_EURJPY,true);
   ArraySetAsSeries(LOW_F_EURJPY,true);
   ArraySetAsSeries(CLOSE_F_EURJPY,true);     
       
     
   ArraySetAsSeries(OPEN_S_GBPJPY,true);
   ArraySetAsSeries(HIGH_S_GBPJPY,true);
   ArraySetAsSeries(LOW_S_GBPJPY,true);
   ArraySetAsSeries(CLOSE_S_GBPJPY,true);
   ArraySetAsSeries(OPEN_F_GBPJPY,true);
   ArraySetAsSeries(HIGH_F_GBPJPY,true);
   ArraySetAsSeries(LOW_F_GBPJPY,true);
   ArraySetAsSeries(CLOSE_F_GBPJPY,true);         
     
   ArraySetAsSeries(OPEN_S_USDJPY,true);
   ArraySetAsSeries(HIGH_S_USDJPY,true);
   ArraySetAsSeries(LOW_S_USDJPY,true);
   ArraySetAsSeries(CLOSE_S_USDJPY,true);
   ArraySetAsSeries(OPEN_F_USDJPY,true);
   ArraySetAsSeries(HIGH_F_USDJPY,true);
   ArraySetAsSeries(LOW_F_USDJPY,true);
   ArraySetAsSeries(CLOSE_F_USDJPY,true);         
   
   for(i=prev_calculated;i<rates_total;i++)
     {          
      if (Symbol() == "EURUSD")
        {     
// ----  OPEN=EUR(Mode,PRICE_OPEN,i,per1,per2)-USD(Mode,PRICE_OPEN,i,per1,per2);          
         OPEN=((OPEN_F_EURUSD[i]-OPEN_S_EURUSD[i])*10000*kUSD+(OPEN_F_EURGBP[i]-OPEN_S_EURGBP[i])*10000*kGBP+(OPEN_F_EURJPY[i]-OPEN_S_EURJPY[i])*100*kJPY -
               (OPEN_S_EURUSD[i]-OPEN_F_EURUSD[i])*10000*kEUR+(OPEN_S_GBPUSD[i]-OPEN_F_GBPUSD[i])*10000*kGBP+(OPEN_F_USDJPY[i]-OPEN_S_USDJPY[i])*100*kJPY);
               
// ----  HIGH=EUR(Mode,PRICE_HIGH,i,per1,per2)-USD(Mode,PRICE_HIGH,i,per1,per2);              
         HIGH=((HIGH_F_EURUSD[i]-HIGH_S_EURUSD[i])*10000*kUSD+(HIGH_F_EURGBP[i]-HIGH_S_EURGBP[i])*10000*kGBP+(HIGH_F_EURJPY[i]-HIGH_S_EURJPY[i])*100*kJPY -
               (HIGH_S_EURUSD[i]-HIGH_F_EURUSD[i])*10000*kEUR+(HIGH_S_GBPUSD[i]-HIGH_F_GBPUSD[i])*10000*kGBP+(HIGH_F_USDJPY[i]-HIGH_S_USDJPY[i])*100*kJPY);
               
// ----  LOW=EUR(Mode,PRICE_LOW,i,per1,per2)-USD(Mode,PRICE_LOW,i,per1,per2);
         LOW=((LOW_F_EURUSD[i]-LOW_S_EURUSD[i])*10000*kUSD+(LOW_F_EURGBP[i]-LOW_S_EURGBP[i])*10000*kGBP+(LOW_F_EURJPY[i]-LOW_S_EURJPY[i])*100*kJPY -
               (LOW_S_EURUSD[i]-LOW_F_EURUSD[i])*10000*kEUR+(LOW_S_GBPUSD[i]-LOW_F_GBPUSD[i])*10000*kGBP+(LOW_F_USDJPY[i]-LOW_S_USDJPY[i])*100*kJPY);
               
// ---   CLOSE=EUR(Mode,PRICE_CLOSE,i,per1,per2)-USD(Mode,PRICE_CLOSE,i,per1,per2);
         CLOSE=((CLOSE_F_EURUSD[i]-CLOSE_S_EURUSD[i])*10000*kUSD+(CLOSE_F_EURGBP[i]-CLOSE_S_EURGBP[i])*10000*kGBP+(CLOSE_F_EURJPY[i]-CLOSE_S_EURJPY[i])*100*kJPY -
               (CLOSE_S_EURUSD[i]-CLOSE_F_EURUSD[i])*10000*kEUR+(CLOSE_S_GBPUSD[i]-CLOSE_F_GBPUSD[i])*10000*kGBP+(CLOSE_F_USDJPY[i]-CLOSE_S_USDJPY[i])*100*kJPY);
         }
      
      pair[i]=(OPEN+HIGH+LOW+CLOSE)/4;      
     
     } //   for
   return(rates_total);
  }

void OnDeinit(const int reason) 
  {
   IndicatorRelease(hMA_OPEN_S_EURUSD); IndicatorRelease(hMA_HIGH_S_EURUSD); IndicatorRelease(hMA_LOW_S_EURUSD); IndicatorRelease(hMA_CLOSE_S_EURUSD);
   IndicatorRelease(hMA_OPEN_F_EURUSD); IndicatorRelease(hMA_HIGH_F_EURUSD); IndicatorRelease(hMA_LOW_F_EURUSD); IndicatorRelease(hMA_CLOSE_F_EURUSD);
 
   IndicatorRelease(hMA_OPEN_S_GBPUSD); IndicatorRelease(hMA_HIGH_S_GBPUSD); IndicatorRelease(hMA_LOW_S_GBPUSD); IndicatorRelease(hMA_CLOSE_S_GBPUSD);
   IndicatorRelease(hMA_OPEN_F_GBPUSD); IndicatorRelease(hMA_HIGH_F_GBPUSD); IndicatorRelease(hMA_LOW_F_GBPUSD); IndicatorRelease(hMA_CLOSE_F_GBPUSD);
   
   IndicatorRelease(hMA_OPEN_S_EURGBP); IndicatorRelease(hMA_HIGH_S_EURGBP); IndicatorRelease(hMA_LOW_S_EURGBP); IndicatorRelease(hMA_CLOSE_S_EURGBP);
   IndicatorRelease(hMA_OPEN_F_EURGBP); IndicatorRelease(hMA_HIGH_F_EURGBP); IndicatorRelease(hMA_LOW_F_EURGBP); IndicatorRelease(hMA_CLOSE_F_EURGBP);
   
   IndicatorRelease(hMA_OPEN_S_EURJPY); IndicatorRelease(hMA_HIGH_S_EURJPY); IndicatorRelease(hMA_LOW_S_EURJPY); IndicatorRelease(hMA_CLOSE_S_EURJPY);
   IndicatorRelease(hMA_OPEN_F_EURJPY); IndicatorRelease(hMA_HIGH_F_EURJPY); IndicatorRelease(hMA_LOW_F_EURJPY); IndicatorRelease(hMA_CLOSE_F_EURJPY);
   
   IndicatorRelease(hMA_OPEN_S_USDJPY); IndicatorRelease(hMA_HIGH_S_USDJPY); IndicatorRelease(hMA_LOW_S_USDJPY); IndicatorRelease(hMA_CLOSE_S_USDJPY);
   IndicatorRelease(hMA_OPEN_F_USDJPY); IndicatorRelease(hMA_HIGH_F_USDJPY); IndicatorRelease(hMA_LOW_F_USDJPY); IndicatorRelease(hMA_CLOSE_F_USDJPY);
   
   IndicatorRelease(hMA_OPEN_S_GBPJPY); IndicatorRelease(hMA_HIGH_S_GBPJPY); IndicatorRelease(hMA_LOW_S_GBPJPY); IndicatorRelease(hMA_CLOSE_S_GBPJPY);
   IndicatorRelease(hMA_OPEN_F_GBPJPY); IndicatorRelease(hMA_HIGH_F_GBPJPY); IndicatorRelease(hMA_LOW_F_GBPJPY); IndicatorRelease(hMA_CLOSE_F_GBPJPY);   
   
  }


/*

double USD(int Mode, int Price, int i, int per1, int per2){
   return(
            (iMA("EURUSD",0,per1,0,Mode,Price,i)-
            iMA("EURUSD",0,per2,0,Mode,Price,i))*10000*kEUR
            +
            (iMA("GBPUSD",0,per1,0,Mode,Price,i)-
            iMA("GBPUSD",0,per2,0,Mode,Price,i))*10000*kGBP
            +           
            (iMA("USDJPY",0,per2,0,Mode,Price,i)-
            iMA("USDJPY",0,per1,0,Mode,Price,i))*100*kJPY
          );
   
}   

double EUR(int Mode, int Price, int i, int per1, int per2){
   return(
            (iMA("EURUSD",0,per2,0,Mode,Price,i)-
            iMA("EURUSD",0,per1,0,Mode,Price,i))*10000*kUSD
            +
            (iMA("EURGBP",0,per2,0,Mode,Price,i)-
            iMA("EURGBP",0,per1,0,Mode,Price,i))*10000*kGBP
            +
            (iMA("EURJPY",0,per2,0,Mode,Price,i)-
            iMA("EURJPY",0,per1,0,Mode,Price,i))*100*kJPY
          ); 
   
}   

double GBP(int Mode, int Price, int i, int per1, int per2){
   return(
            (iMA("GBPUSD",0,per2,0,Mode,Price,i)-
            iMA("GBPUSD",0,per1,0,Mode,Price,i))*10000*kUSD
            +
            (iMA("EURGBP",0,per1,0,Mode,Price,i)-
            iMA("EURGBP",0,per2,0,Mode,Price,i))*10000*kEUR
            +
            (iMA("GBPJPY",0,per2,0,Mode,Price,i)-
            iMA("GBPJPY",0,per1,0,Mode,Price,i))*100*kJPY
          );
   
}   

double JPY(int Mode, int Price, int i, int per1, int per2){
   return(
            (iMA("USDJPY",0,per1,0,Mode,Price,i)-
            iMA("USDJPY",0,per2,0,Mode,Price,i))*100*kUSD
            +
            (iMA("EURJPY",0,per1,0,Mode,Price,i)-
            iMA("EURJPY",0,per2,0,Mode,Price,i))*100*kEUR
            +
            (iMA("GBPJPY",0,per1,0,Mode,Price,i)-
            iMA("GBPJPY",0,per2,0,Mode,Price,i))*100*kGBP          
          );
   
}   
*/
